Framework:Javascript Data GridAngular Data GridReact Data GridVue Data Grid

React Data Grid: Overlay Component

Overlay components allow you to add your own overlays to AG Grid. Use these when the provided overlays do not meet your requirements.

Simple Loading Overlay Component

Below is an example of overlay component with custom loadingMessage param as a Hook:

export default props => {
   return (
       <div className="ag-custom-loading-cell" style={{paddingLeft: '10px', lineHeight: '25px'}}>
           <i className="fas fa-spinner fa-pulse"></i> <span> {props.loadingMessage}</span>
       </div>
   );
};

const gridOptions: GridOptions = {
 ...
 loadingOverlayComponent: CustomLoadingOverlay,
 loadingOverlayComponentParams: {
   loadingMessage: 'One moment please...',
 },
}

And here is the same example as a Class-based Component:

export default class CustomLoadingOverlay extends Component {
   render() {
       return (
           <div className="ag-overlay-loading-center" style={{backgroundColor: 'lightsteelblue', height: '9%'}}>
               <i className="fas fa-hourglass-half"> {this.props.loadingMessage} </i>
           </div>
       );
   }
}

const gridOptions: GridOptions = {
 ...
 loadingOverlayComponent: CustomLoadingOverlay,
 loadingOverlayComponentParams: {
   loadingMessage: 'One moment please...',
 },
}

Simple No-Rows Overlay Component

Below is an example of a no rows overlay component with custom noRowsMessageFunc() params as a Hook:

export default props => {
   return (
       <div className="ag-overlay-loading-center" style={{backgroundColor: 'lightcoral', height: '9%'}}>
           <i className="far fa-frown"> {props.noRowsMessageFunc()}</i>
       </div>
   );
};

const gridOptions: GridOptions = {
 ...
 noRowsOverlayComponent: CustomNoRowsOverlay,
 noRowsOverlayComponentParams: {
   noRowsMessageFunc: () => 'Sorry - no rows! at: ' + new Date(),
 },
}

And here is the same example as a Class-based Component:

export default class CustomNoRowsOverlay extends Component {
   render() {
       return (
           <div className="ag-overlay-loading-center" style={{backgroundColor: 'lightcoral', height: '9%'}}>
               <i className="far fa-frown"> {this.props.noRowsMessageFunc()}</i>
           </div>
       );
   }
}

const gridOptions: GridOptions = {
 ...
 noRowsOverlayComponent: CustomNoRowsOverlay,
 noRowsOverlayComponentParams: {
   noRowsMessageFunc: () => 'Sorry - no rows! at: ' + new Date(),
 },
}

Example: Custom Overlay Components

The example below demonstrates how to provide custom overlay components to the grid. Notice the following:

  • Custom Loading Overlay Renderer is supplied by name via gridOptions.loadingOverlayComponent.
  • Custom Loading Overlay Renderer Parameters are supplied using gridOptions loadingOverlayComponentParams.
  • Custom No Rows Overlay Renderer is supplied by name via gridOptions.noRowsOverlayComponent.
  • Custom No Rows Overlay Renderer Parameters are supplied using gridOptions.noRowsOverlayComponentParams.

Overlay Component Interface

Any valid React component can be an Overlay. When a custom Overlay Component is instantiated within both a template and the Grid API will be made available on props:

ILoadingOverlayParams

Properties available on the ILoadingOverlayParams interface.

api
GridApi

INoRowsOverlayParams

Properties available on the INoRowsOverlayParams interface.

api
GridApi

Registering Overlay Components

See the section registering custom components for details on registering and using custom overlays.

Framework:Javascript Data GridAngular Data GridReact Data GridVue Data Grid

Angular Data Grid: Overlay Component

Overlay components allow you to add your own overlays to AG Grid. Use these when the provided overlays do not meet your requirements.

Simple Loading Overlay Component

Below is a example of loading overlay class with a custom loadingMessage param:

import {Component} from '@angular/core';
import {ILoadingOverlayParams} from "@ag-grid-community/core";
import {ILoadingOverlayAngularComp} from "@ag-grid-community/angular";

@Component({
   selector: 'app-loading-overlay',
   template: `
     <div class="ag-overlay-loading-center" style="background-color: lightsteelblue;">
       <i class="fas fa-hourglass-half">{{ this.params.loadingMessage }} </i>
     </div>
   `
})
export class CustomLoadingOverlay implements ILoadingOverlayAngularComp {
   public params: ILoadingOverlayParams & { loadingMessage: string};

   agInit(params: ILoadingOverlayParams & { loadingMessage: string}): void {
       this.params = params;
   }
}

const gridOptions: GridOptions = {
 ...
 loadingOverlayComponent: CustomLoadingOverlay,
 loadingOverlayComponentParams: {
   loadingMessage: 'One moment please...',
 },
}

Simple No-Rows Overlay Component

Below is an example of no rows overlay class with custom noRowsMessageFunc() param:

import {Component} from '@angular/core';
import {INoRowsOverlayParams} from "@ag-grid-community/core";
import {INoRowsOverlayAngularComp} from "@ag-grid-community/angular";

@Component({
   selector: 'app-no-rows-overlay',
   template: `
     <div class="ag-overlay-loading-center" style="background-color: lightcoral;">
       <i class="far fa-frown"> {{ this.params.noRowsMessageFunc() }} </i>
     </div>`
})
export class CustomNoRowsOverlay implements INoRowsOverlayAngularComp {
   public params: INoRowsOverlayParams & { noRowsMessageFunc: () => string};

   agInit(params: INoRowsOverlayParams & { noRowsMessageFunc: () => string}): void {
       this.params = params;
   }
}

const gridOptions: GridOptions = {
 ...
 noRowsOverlayComponent: CustomNoRowsOverlay,
 noRowsOverlayComponentParams: {
   noRowsMessageFunc: () => 'Sorry - no rows! at: ' + new Date(),
 },
}

Example: Custom Overlay Components

The example below demonstrates how to provide custom overlay components to the grid. Notice the following:

  • Custom Loading Overlay Renderer is supplied by name via gridOptions.loadingOverlayComponent.
  • Custom Loading Overlay Renderer Parameters are supplied using gridOptions loadingOverlayComponentParams.
  • Custom No Rows Overlay Renderer is supplied by name via gridOptions.noRowsOverlayComponent.
  • Custom No Rows Overlay Renderer Parameters are supplied using gridOptions.noRowsOverlayComponentParams.

Overlay Components Interfaces

Loading Overlay

Implement this interface to provide a custom overlay when data is being loaded.

interface extends ILoadingOverlayAngularComp { // The agInit(params) method is called on the overlay once. See below for details on the parameters. agInit(params: ILoadingOverlayParams); }

No Rows Overlay

Implement this interface to provide a custom overlay when no rows loaded.

interface extends INowRowsOverlayAngularComp { // The agInit(params) method is called on the overlay once. See below for details on the parameters. agInit(params: INoRowsOverlayParams); }

The agInit(params) method takes a params object with the items listed below:

ILoadingOverlayParams

Properties available on the ILoadingOverlayParams interface.

api
GridApi

INoRowsOverlayParams

Properties available on the INoRowsOverlayParams interface.

api
GridApi

Registering Overlay Components

See the section registering custom components for details on registering and using custom overlays.